import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import MoleculeField from '@s-ui/react-molecule-field';
import AtomTextarea, { AtomTextareaSizes as SIZES, AtomTextareaStates } from '@s-ui/react-atom-textarea';
import WithCharacterCount from './hoc/WithCharacterCount';

var hasErrors = function hasErrors(_ref) {
  var successText = _ref.successText,
      errorText = _ref.errorText;
  if (errorText) return true;
  if (successText) return false;
};

var getState = function getState(_ref2) {
  var successText = _ref2.successText,
      errorState = _ref2.errorState,
      alertText = _ref2.alertText;
  if (successText) return AtomTextareaStates.SUCCESS;
  if (errorState) return AtomTextareaStates.ERROR;
  if (alertText) return AtomTextareaStates.ALERT;
};

var MoleculeTextareaField = WithCharacterCount(function (_ref3) {
  var id = _ref3.id,
      label = _ref3.label,
      maxChars = _ref3.maxChars,
      textCharacters = _ref3.textCharacters,
      successText = _ref3.successText,
      errorText = _ref3.errorText,
      alertText = _ref3.alertText,
      helpText = _ref3.helpText,
      onChange = _ref3.onChange,
      props = _objectWithoutPropertiesLoose(_ref3, ["id", "label", "maxChars", "textCharacters", "successText", "errorText", "alertText", "helpText", "onChange"]);

  var errorState = hasErrors({
    successText: successText,
    errorText: errorText
  });
  var textAreaState = getState({
    successText: successText,
    errorState: errorState,
    alertText: alertText
  });
  return React.createElement(MoleculeField, {
    name: id,
    label: label,
    textCharacters: textCharacters,
    successText: successText,
    errorText: errorText,
    alertText: alertText,
    helpText: helpText,
    maxChars: maxChars,
    onChange: onChange
  }, React.createElement(AtomTextarea, Object.assign({
    id: id,
    errorState: errorState,
    state: textAreaState
  }, props)));
});
MoleculeTextareaField.displayName = 'MoleculeTextareaField';
MoleculeTextareaField.defaultProps = {
  maxChars: 4000
};
export default MoleculeTextareaField;